package com.huimv.admin.system.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.huimv.admin.system.entity.AccountGroup;
import com.huimv.admin.system.entity.AppSysAccountGroup;
import com.huimv.admin.system.entity.AppSysGroup;
import com.huimv.admin.system.entity.Group;
import com.huimv.admin.system.service.*;
import com.huimv.common.token.TokenSign;
import com.huimv.common.utils.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;


@RestController
@RequestMapping("/app/group")
public class AppSysGroupController {

    @Autowired
    private IAppSysGroupService groupService;

    @Autowired
    private IAppSysAccountGroupService accountGroupService;
    @Autowired
    private ISysAccountMultilevelService accountMultilevelService;

    @PostMapping("/add")
    public Result addGroup (@RequestBody AppSysGroup group, HttpServletRequest request){
        Integer userId = TokenSign.getMemberIdByJwtToken(request);
        return groupService.addGroup(group,userId);
    }


    @PostMapping("/edit")
    public Result updateGroup(@RequestBody AppSysGroup group ){
        return groupService.updateGroup( group);
    }

    @RequestMapping("/remove")
    public Result removeGroup(@RequestParam("groupId") Integer groupId) {

        accountGroupService.remove(new QueryWrapper<AppSysAccountGroup>().in("group_id",groupId));
        return groupService.removeGroup(groupId);
    }

    @PostMapping("/list")
    public IPage<AppSysGroup> listGroup(@RequestBody Map map , HttpServletRequest request) {
        Integer userId = TokenSign.getMemberIdByJwtToken(request);
        List<Integer> allChildId = accountMultilevelService.getAllChildId(userId);
        return groupService.listGroup(map,allChildId);
    }
}
